# TODO: compiled modules
#
# Conditional build:
%bcond_without	doc	# API documentation
%bcond_without	tests	# unit tests

Summary:	Optional static typing for Python
Summary(pl.UTF-8):	Opcjonalne typowanie statyczne dla Pythona
Name:		python3-mypy
Version:	1.16.1
Release:	1
License:	MIT, PSF v2
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/mypy/
Source0:	https://files.pythonhosted.org/packages/source/m/mypy/mypy-%{version}.tar.gz
# Source0-md5:	ef112a3b408fbef0ea20fc9abc1f5a92
URL:		https://pypi.org/project/mypy/
BuildRequires:	python3-devel >= 1:3.9
BuildRequires:	python3-mypy_extensions >= 1.0.0
BuildRequires:	python3-pathspec >= 0.9.0
BuildRequires:	python3-setuptools >= 1:75.1.0
%if "%{_ver_lt %{py3_ver} 3.11}" == "1"
BuildRequires:	python3-tomli >= 1.1.0
%endif
BuildRequires:	python3-types-psutil
BuildRequires:	python3-types-setuptools
BuildRequires:	python3-typing_extensions >= 4.6.0
%if %{with tests}
BuildRequires:	python3-attrs >= 18.0
BuildRequires:	python3-filelock >= 3.3.0
BuildRequires:	python3-lxml >= 5.3.0
BuildRequires:	python3-pytest >= 8.1.0
BuildRequires:	python3-pytest-cov >= 2.10.0
BuildRequires:	python3-pytest-xdist >= 1.34.0
BuildRequires:	python3-tomli >= 1.1.0
%endif
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
BuildRequires:	python3-furo >= 2022.3.4
BuildRequires:	python3-myst_parser >= 4.0.0
BuildRequires:	python3-sphinx_inline_tabs >= 2023.04.21
BuildRequires:	sphinx-pdg-3 >= 8.1
%endif
Requires:	python3-modules >= 1:3.9
# only if without compiled modules
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Add type annotations to your Python programs, and use mypy to type
check them. Mypy is essentially a Python linter on steroids, and it
can catch many programming errors by analyzing your program, without
actually having to run it. Mypy has a powerful type system with
features such as type inference, gradual typing, generics and union
types.

%description -l pl.UTF-8
Przy użyciu mypy można sprawdzić typy używane w programach w Pythonie
po dodaniu do nich znaczników typów. Mypy o zasadniczo pythonowy
linter "na sterydach", potrafi wyłapać wiele błędów programisty
poprzez analizę programu, bez potrzeby uruchamiania go. Ma potężny
system typów, z funkcjonalnością taką jak wnioskowanie typów,
typowanie stopniowe, typy generyczne czy unie.

%package apidocs
Summary:	API documentation for Python mypy module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona mypy
Group:		Documentation

%description apidocs
API documentation for Python mypy module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona mypy.

%prep
%setup -q -n mypy-%{version}

%build
%py3_build

%if %{with tests}
# some PEP561Suite tests use network
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS=xdist.plugin \
%{__python3} -m pytest mypy mypyc -k 'not PEP561Suite'
%endif

%if %{with doc}
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install

%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/mypy/test
%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/mypyc/test

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGELOG.md LICENSE README.md
%attr(755,root,root) %{_bindir}/dmypy
%attr(755,root,root) %{_bindir}/mypy
%attr(755,root,root) %{_bindir}/mypyc
%attr(755,root,root) %{_bindir}/stubgen
%attr(755,root,root) %{_bindir}/stubtest
%{py3_sitescriptdir}/mypy
%{py3_sitescriptdir}/mypyc
%{py3_sitescriptdir}/mypy-%{version}-py*.egg-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/build/html/{_static,*.html,*.js}
%endif
%changelog
* Fri Jul 04 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-mypy.git;a=log;h=master

* Thu Jul 03 2025 Jakub Bogusz <qboosh@pld-linux.org> 42aae10
- new

